# Problem 1 - Hail Stones Solution 

def main():
    inFile = open("Prob1.in", "r")
    outFile = open("Prob1.out", "w")
    caseNo = 0
    for line in inFile:
        caseNo += 1
        N = int(line.strip('\n'))
        if N == -1:
            break
        else:
            seqLength = hailstoneSeqLength(N)
            outFile.write("Case %d: length = %d for N = %d\n\n"%
                          (caseNo, seqLength, N))
            print "Case %d: length = %d for N = %d\n"%(caseNo, seqLength, N)

            seqLength = hailstoneSeqLengthRecursive(N)
            print "Case %d: length = %d for N = %d (Recursive)\n"%(caseNo, seqLength, N)
    inFile.close()
    outFile.close()

def hailstoneSeqLength(N):
    # iterative (non-recursive) function
    seqLength = 1
    while N != 1:
        if N % 2 == 1:  # N is odd
            N = 3 * N + 1
        else:           # N is even
            N = N / 2
        seqLength += 1
    return seqLength

def hailstoneSeqLengthRecursive(N):
    # Recursive function
    if N == 1:
        return 1
    elif N % 2 == 1:  # N is odd
        return hailstoneSeqLengthRecursive(3 * N + 1) + 1
    else:             # N is even
        return hailstoneSeqLengthRecursive(N / 2) + 1            


main()
